/******************************************************************************
 *                        TMBOInteg.cpp  -  description
 *                            -------------------
 *   begin                : 2005/05/26
 *   copyright            : (C) 2005 by Harald K. Strack
 *   copyright            : (C) 2005 by Trymedia Inc.
 *   email                : hstrack@trymedia.com
 ******************************************************************************
 * changes	name	date	comment
*/


/* TMBOInteg: Trymedia Handler for the ap4 Integ command.
 * 
 * Is the same as TMBOSync ;-), but with SetFileSys ()
 * 
 * This handler gets the versioned filenames (vpath, vnpath) from 
 * TMSyncClient::Message(). The filnames (path, its the path of
 * the new branch!!!) it gets from SetFileSys() and a hook in TMFSHook.
 * The reason for this double way of getting filenames is
 * just to find coding errors. It helped a lot!
 * 
 * With this data it can perform any actions an any files after the sync call.
 * 
 * 
 */


#include "TMBOInteg.h"

TMBOInteg::TMBOInteg ()
{
}

TMBOInteg::~TMBOInteg ()
{
}

/* String for errormessages */
StrBuf & TMBOInteg::GetDescription ()
{
	StrBuf *
	buf = new StrBuf;
	buf->Set ("TRYMEDIA INTEGRATION HANDLER");
	return *buf;
}

/* Adds a FileSys->path pointer to the internal linked list
 * Usefull for filesystem hooks. */
void
TMBOInteg::SetFileSys (FileSys * fs)
{
	PushNode ();
	/* Sets the path of the NEW file !!! */
	SetPath (GetHeadNode (), &fs->Path ());
}
